apiVersion: batch/v1beta1
kind: CronJob
metadata:
  labels:
    {{ network_policy_deployment_label }}: {{ opensearch_name }}
  name: {{ opensearch_name }}-shardfix
  namespace: {{ namespace }}
spec:
  concurrencyPolicy: Forbid
  failedJobsHistoryLimit: 3
  jobTemplate:
    metadata:
      labels:
        name: {{ opensearch_name }}-shardfix
    spec:
      template:
        metadata:
          labels:
            name: {{ opensearch_name }}-shardfix
        spec:
          automountServiceAccountToken: false
          containers:
          - args:
            - -c
            - |
                echo Looking for UNASSIGNED Shards on $(date +%s)
                wget -O- \
                   'http://{{ opensearch_name }}-client:9200/_cat/shards' 2>/dev/null \
                   | awk '/UNASSIGNED/{print $1}' \
                   | while read idx; do \
                         echo "Fixing $idx Shards"
                         wget \
                              --header 'Content-Type: application/json' \
                              --method=PUT "http://{{ opensearch_name }}-client:9200/$idx/_settings" \
                              --body-data='{ "index": {"number_of_replicas": 0 } }' -O-
                     done
                echo Done on $(date +%s)
            command:
            - /bin/sh
            image: {{ (opsimages | json_query("[?name=='opensearch'].image"))[0] }}
            imagePullPolicy: {{ pull_policy }}
            name: job
            resources:
              limits:
                cpu: 100m
                memory: 128Mi
              requests:
                cpu: 10m
                memory: 64Mi
{% if k8s_resource_nodes_selectors | length > 0 %}
          nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
            {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
          restartPolicy: OnFailure
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
          priorityClassName: opsperator-jobs
{% endif %}
{% if job_allow_unschedulable | default(True) %}
          tolerations:
          - operator: Exists
{% else %}
          tolerations: {}
{% endif %}
  schedule: 3 * * * *
  startingDeadlineSeconds: 120
  successfulJobsHistoryLimit: 1
  suspend: false
